Skip to content

MultiSelect cell type

Collect user input with a list of multiple-selection choices, by using the MultiSelect cell type.

The multiselect cell type lets users pick multiple values from a dropdown list. Values are stored as a comma-separated string or array.

Overview

The MultiSelect cell type is designed for scenarios where you need to save and manage a list of values within a single cell. With this cell type, users can open a dropdown menu containing all available options and select any number of values, rather than being limited to just one.

Once selections are made, the values are stored in the table’s source data as an array associated with that particular cell. This approach provides both flexibility and clarity when working with datasets that require multiple values per field.

For a clear visual representation, the MultiSelect renderer displays each selected value as an individual, removable chip within the cell. This makes it easy for users to see exactly which values are selected at a glance and to remove any item with a single action if needed.

The list of selectable options (source property) can be provided in two formats:

  • An array of values
  • An array of objects with key and value properties

Integration with formulas

When you use the MultiSelect cell type together with the Formulas plugin, Handsontable keeps MultiSelect values in source data as arrays.

HyperFormula doesn’t accept arrays as direct cell values. Because of that, Handsontable converts MultiSelect arrays to comma-separated strings before passing values to HyperFormula. This behavior keeps the original array format in source data, and allows formula cells to reference MultiSelect values as text (for example, "Frontend, Backend").

The source option

The source option can be provided in two formats:

Array of values

You can provide the source option as an array of values that will be used as the MultiSelect options.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1');
const shipmentCategories = [
'Electronics and Gadgets',
'Medical Supplies',
'Auto Parts',
'Fresh Produce',
'Textiles',
'Industrial Equipment',
'Pharmaceuticals',
'Consumer Goods',
'Machine Parts',
'Food Products',
];
const data = [
['Los Angeles International Airport', ['Electronics and Gadgets', 'Medical Supplies']],
["Chicago O'Hare International Airport", ['Auto Parts', 'Fresh Produce']],
['Charles de Gaulle Airport', ['Textiles', 'Industrial Equipment']],
['Tokyo Haneda Airport', ['Pharmaceuticals', 'Consumer Goods']],
['Singapore Changi Airport', ['Machine Parts', 'Food Products']],
['Luton Airport', ['Electronics and Gadgets', 'Pharmaceuticals']],
['Frankfurt Airport', ['Industrial Equipment', 'Auto Parts', 'Consumer Goods']],
['Sydney Kingsford Smith Airport', ['Fresh Produce', 'Food Products']],
['Toronto Pearson International Airport', ['Medical Supplies', 'Textiles']],
['Hong Kong International Airport', ['Machine Parts', 'Electronics and Gadgets', 'Industrial Equipment']],
['Heathrow Airport', ['Textiles', 'Consumer Goods']],
];
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1')!;
const shipmentCategories = [
'Electronics and Gadgets',
'Medical Supplies',
'Auto Parts',
'Fresh Produce',
'Textiles',
'Industrial Equipment',
'Pharmaceuticals',
'Consumer Goods',
'Machine Parts',
'Food Products',
];
const data = [
['Los Angeles International Airport', ['Electronics and Gadgets', 'Medical Supplies']],
['Chicago O\'Hare International Airport', ['Auto Parts', 'Fresh Produce']],
['Charles de Gaulle Airport', ['Textiles', 'Industrial Equipment']],
['Tokyo Haneda Airport', ['Pharmaceuticals', 'Consumer Goods']],
['Singapore Changi Airport', ['Machine Parts', 'Food Products']],
['Luton Airport', ['Electronics and Gadgets', 'Pharmaceuticals']],
['Frankfurt Airport', ['Industrial Equipment', 'Auto Parts', 'Consumer Goods']],
['Sydney Kingsford Smith Airport', ['Fresh Produce', 'Food Products']],
['Toronto Pearson International Airport', ['Medical Supplies', 'Textiles']],
['Hong Kong International Airport', ['Machine Parts', 'Electronics and Gadgets', 'Industrial Equipment']],
['Heathrow Airport', ['Textiles', 'Consumer Goods']],
];
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
});

Array of objects

You can provide the source option as an array of objects with key and value properties. The value property will be used as the MultiSelect’s option label, while the entire object will be used as the value saved to the cell’s source data.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example2');
const shipmentCategories = [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
];
const data = [
[
'Los Angeles International Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
],
],
[
"Chicago O'Hare International Airport",
[
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
],
],
[
'Charles de Gaulle Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Tokyo Haneda Airport',
[
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Singapore Changi Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Luton Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
],
],
[
'Frankfurt Airport',
[
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Sydney Kingsford Smith Airport',
[
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Toronto Pearson International Airport',
[
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'textiles', value: 'Textiles' },
],
],
[
'Hong Kong International Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Heathrow Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
];
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example2')!;
const shipmentCategories = [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
];
const data = [
['Los Angeles International Airport', [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
]],
['Chicago O\'Hare International Airport', [
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
]],
['Charles de Gaulle Airport', [
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
]],
['Tokyo Haneda Airport', [
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
]],
['Singapore Changi Airport', [
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
]],
['Luton Airport', [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
]],
['Frankfurt Airport', [
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'consumer', value: 'Consumer Goods' },
]],
['Sydney Kingsford Smith Airport', [
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'food', value: 'Food Products' },
]],
['Toronto Pearson International Airport', [
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'textiles', value: 'Textiles' },
]],
['Hong Kong International Airport', [
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'industrial', value: 'Industrial Equipment' },
]],
['Heathrow Airport', [
{ key: 'textiles', value: 'Textiles' },
{ key: 'consumer', value: 'Consumer Goods' },
]],
];
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
});

Keyboard navigation

The MultiSelect editor is a dropdown with selectable items. You can select items by clicking them or by using the keyboard:

When the dropdown opens, the initial focus depends on the searchInput option: if filtering is enabled, the search input is focused by default; if filtering is disabled, the first item in the list is focused.

  • – Move the focus between items in the dropdown list. When the search input is visible, use to move focus from the search input into the list, and to move focus back into the search input.
  • Space or Enter – Toggle the selection of the focused item. The behavior depends on the enterCommits option:
    • When enterCommits is true (default): Enter closes the editor and commits the selection; Space toggles the focused item’s selection.
    • When enterCommits is false: Enter toggles the focused item’s selection; Space has no effect.

Each selection (or deselection) immediately updates the underlying cell data.

Other options

The MultiSelect cell type provides several configuration options to tailor its behavior:

  • allowEmpty – Allows empty cell value to pass validation. This is set to true by default.
  • placeholder – Sets placeholder text that’s rendered in the cell when the cell is empty.
  • visibleRows – Defines the maximum number of visible rows in the dropdown menu.
  • maxSelections – Determines the maximum number of items that can be selected.
  • sourceSortFunction – A custom sort function to order the dropdown entries.
  • enterCommits – Controls whether pressing the Enter key closes the editor and commits the selection.
  • searchInput – Toggles the visibility of the search input inside the dropdown.
  • filteringCaseSensitive – When set to true, the dropdown’s search filtering is case sensitive.

These options allow you to modify the MultiSelect cell type’s appearance, usability, and behavior to better fit your specific needs.

The demo below showcases some the options in an interactive example.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example3');
const requiredItems = ['Passport', 'Tickets', 'Wallet', 'Phone', 'Keys'];
const optionalExtras = ['Snacks', 'Book', 'Camera', 'Umbrella', 'First aid kit'];
const interests = ['Art', 'History', 'Nature', 'Food', 'Shopping'];
const data = [
[['Passport', 'Phone'], ['Snacks', 'Book'], ['Nature']],
[['Tickets', 'Wallet'], ['Camera'], []],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
];
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data,
columns: [
{
type: 'multiselect',
source: requiredItems,
title: 'Required items',
allowEmpty: false,
},
{
type: 'multiselect',
source: optionalExtras,
title: 'Optional extras',
placeholder: 'Select up to 3',
maxSelections: 3,
visibleRows: 4,
searchInput: false,
},
{
type: 'multiselect',
source: interests,
title: 'Interests',
placeholder: 'Select interests',
sourceSortFunction: (entries) => [...entries].sort((a, b) => a.localeCompare(b)),
filteringCaseSensitive: true,
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example3')!;
const requiredItems = ['Passport', 'Tickets', 'Wallet', 'Phone', 'Keys'];
const optionalExtras = ['Snacks', 'Book', 'Camera', 'Umbrella', 'First aid kit'];
const interests = ['Art', 'History', 'Nature', 'Food', 'Shopping'];
const data = [
[['Passport', 'Phone'], ['Snacks', 'Book'], ['Nature']],
[['Tickets', 'Wallet'], ['Camera'], []],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
];
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data,
columns: [
{
type: 'multiselect',
source: requiredItems,
title: 'Required items',
allowEmpty: false,
},
{
type: 'multiselect',
source: optionalExtras,
title: 'Optional extras',
placeholder: 'Select up to 3',
maxSelections: 3,
visibleRows: 4,
searchInput: false,
},
{
type: 'multiselect',
source: interests,
title: 'Interests',
placeholder: 'Select interests',
sourceSortFunction: (entries: string[]) => [...entries].sort((a, b) => a.localeCompare(b)),
filteringCaseSensitive: true,
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
});

API methods

When working with object-based MultiSelect data, you can use methods like getSourceData(), getSourceDataAtCell(), getSourceDataAtRow() etc., to get the data array in its original object format with both key and value properties. The getData() method will return only the value property’s value in the array.

Result

After configuring the multiselect cell type, cells display a dropdown that allows selecting multiple items. Each selected value appears as a removable chip inside the cell. The underlying data source stores the selections as an array (or as a comma-separated string when used with the Formulas plugin).

Related guides

Related blog articles

Configuration options

Core methods

Hooks

Skip to content

MultiSelect cell type

Collect user input with a list of multiple-selection choices, by using the MultiSelect cell type.

The multiselect cell type lets users pick multiple values from a dropdown list. Values are stored as a comma-separated string or array.

Overview

The MultiSelect cell type is designed for scenarios where you need to save and manage a list of values within a single cell. With this cell type, users can open a dropdown menu containing all available options and select any number of values, rather than being limited to just one.

Once selections are made, the values are stored in the table’s source data as an array associated with that particular cell. This approach provides both flexibility and clarity when working with datasets that require multiple values per field.

For a clear visual representation, the MultiSelect renderer displays each selected value as an individual, removable chip within the cell. This makes it easy for users to see exactly which values are selected at a glance and to remove any item with a single action if needed.

The list of selectable options (source property) can be provided in two formats:

  • An array of values
  • An array of objects with key and value properties

Integration with formulas

When you use the MultiSelect cell type together with the Formulas plugin, Handsontable keeps MultiSelect values in source data as arrays.

HyperFormula doesn’t accept arrays as direct cell values. Because of that, Handsontable converts MultiSelect arrays to comma-separated strings before passing values to HyperFormula. This behavior keeps the original array format in source data, and allows formula cells to reference MultiSelect values as text (for example, "Frontend, Backend").

The source option

The source option can be provided in two formats:

Array of values

You can provide the source option as an array of values that will be used as the MultiSelect options.

JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const shipmentCategories = [
'Electronics and Gadgets',
'Medical Supplies',
'Auto Parts',
'Fresh Produce',
'Textiles',
'Industrial Equipment',
'Pharmaceuticals',
'Consumer Goods',
'Machine Parts',
'Food Products',
];
const data = [
['Los Angeles International Airport', ['Electronics and Gadgets', 'Medical Supplies']],
["Chicago O'Hare International Airport", ['Auto Parts', 'Fresh Produce']],
['Charles de Gaulle Airport', ['Textiles', 'Industrial Equipment']],
['Tokyo Haneda Airport', ['Pharmaceuticals', 'Consumer Goods']],
['Singapore Changi Airport', ['Machine Parts', 'Food Products']],
['Luton Airport', ['Electronics and Gadgets', 'Pharmaceuticals']],
['Frankfurt Airport', ['Industrial Equipment', 'Auto Parts', 'Consumer Goods']],
['Sydney Kingsford Smith Airport', ['Fresh Produce', 'Food Products']],
['Toronto Pearson International Airport', ['Medical Supplies', 'Textiles']],
['Hong Kong International Airport', ['Machine Parts', 'Electronics and Gadgets', 'Industrial Equipment']],
['Heathrow Airport', ['Textiles', 'Consumer Goods']],
];
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
columns={[
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
]}
height="auto"
stretchH="last"
width="100%"
/>
);
};
export default ExampleComponent;
TypeScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const shipmentCategories: string[] = [
'Electronics and Gadgets',
'Medical Supplies',
'Auto Parts',
'Fresh Produce',
'Textiles',
'Industrial Equipment',
'Pharmaceuticals',
'Consumer Goods',
'Machine Parts',
'Food Products',
];
const data: (string | string[])[][] = [
['Los Angeles International Airport', ['Electronics and Gadgets', 'Medical Supplies']],
["Chicago O'Hare International Airport", ['Auto Parts', 'Fresh Produce']],
['Charles de Gaulle Airport', ['Textiles', 'Industrial Equipment']],
['Tokyo Haneda Airport', ['Pharmaceuticals', 'Consumer Goods']],
['Singapore Changi Airport', ['Machine Parts', 'Food Products']],
['Luton Airport', ['Electronics and Gadgets', 'Pharmaceuticals']],
['Frankfurt Airport', ['Industrial Equipment', 'Auto Parts', 'Consumer Goods']],
['Sydney Kingsford Smith Airport', ['Fresh Produce', 'Food Products']],
['Toronto Pearson International Airport', ['Medical Supplies', 'Textiles']],
['Hong Kong International Airport', ['Machine Parts', 'Electronics and Gadgets', 'Industrial Equipment']],
['Heathrow Airport', ['Textiles', 'Consumer Goods']],
];
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
columns={[
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
]}
height="auto"
stretchH="last"
width="100%"
/>
);
};
export default ExampleComponent;

Array of objects

You can provide the source option as an array of objects with key and value properties. The value property will be used as the MultiSelect’s option label, while the entire object will be used as the value saved to the cell’s source data.

JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const shipmentCategories = [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
];
const data = [
[
'Los Angeles International Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
],
],
[
"Chicago O'Hare International Airport",
[
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
],
],
[
'Charles de Gaulle Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Tokyo Haneda Airport',
[
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Singapore Changi Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Luton Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
],
],
[
'Frankfurt Airport',
[
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Sydney Kingsford Smith Airport',
[
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Toronto Pearson International Airport',
[
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'textiles', value: 'Textiles' },
],
],
[
'Hong Kong International Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Heathrow Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
];
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
columns={[
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
]}
height="auto"
stretchH="last"
width="100%"
/>
);
};
export default ExampleComponent;
TypeScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
interface ShipmentCategory {
key: string;
value: string;
}
const shipmentCategories: ShipmentCategory[] = [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
];
const data: (string | ShipmentCategory[])[][] = [
[
'Los Angeles International Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
],
],
[
"Chicago O'Hare International Airport",
[
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
],
],
[
'Charles de Gaulle Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Tokyo Haneda Airport',
[
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Singapore Changi Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Luton Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
],
],
[
'Frankfurt Airport',
[
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Sydney Kingsford Smith Airport',
[
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Toronto Pearson International Airport',
[
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'textiles', value: 'Textiles' },
],
],
[
'Hong Kong International Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Heathrow Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
];
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
columns={[
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
]}
height="auto"
stretchH="last"
width="100%"
/>
);
};
export default ExampleComponent;

Keyboard navigation

The MultiSelect editor is a dropdown with selectable items. You can select items by clicking them or by using the keyboard:

When the dropdown opens, the initial focus depends on the searchInput option: if filtering is enabled, the search input is focused by default; if filtering is disabled, the first item in the list is focused.

  • – Move the focus between items in the dropdown list. When the search input is visible, use to move focus from the search input into the list, and to move focus back into the search input.
  • Space or Enter – Toggle the selection of the focused item. The behavior depends on the enterCommits option:
    • When enterCommits is true (default): Enter closes the editor and commits the selection; Space toggles the focused item’s selection.
    • When enterCommits is false: Enter toggles the focused item’s selection; Space has no effect.

Each selection (or deselection) immediately updates the underlying cell data.

Other options

The MultiSelect cell type provides several configuration options to tailor its behavior:

  • allowEmpty – Allows empty cell value to pass validation. This is set to true by default.
  • placeholder – Sets placeholder text that’s rendered in the cell when the cell is empty.
  • visibleRows – Defines the maximum number of visible rows in the dropdown menu.
  • maxSelections – Determines the maximum number of items that can be selected.
  • sourceSortFunction – A custom sort function to order the dropdown entries.
  • enterCommits – Controls whether pressing the Enter key closes the editor and commits the selection.
  • searchInput – Toggles the visibility of the search input inside the dropdown.
  • filteringCaseSensitive – When set to true, the dropdown’s search filtering is case sensitive.

These options allow you to modify the MultiSelect cell type’s appearance, usability, and behavior to better fit your specific needs.

The demo below showcases some the options in an interactive example.

JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const requiredItems = ['Passport', 'Tickets', 'Wallet', 'Phone', 'Keys'];
const optionalExtras = ['Snacks', 'Book', 'Camera', 'Umbrella', 'First aid kit'];
const interests = ['Art', 'History', 'Nature', 'Food', 'Shopping'];
const sortAlphabetically = (entries) =>
[...entries].sort((a, b) => String(a).localeCompare(String(b)));
const data = [
[['Passport', 'Phone'], ['Snacks', 'Book'], ['Nature']],
[['Tickets', 'Wallet'], ['Camera'], []],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
];
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
columns={[
{
type: 'multiselect',
source: requiredItems,
title: 'Required items',
allowEmpty: false,
},
{
type: 'multiselect',
source: optionalExtras,
title: 'Optional extras',
placeholder: 'Select up to 3',
maxSelections: 3,
visibleRows: 4,
searchInput: false,
},
{
type: 'multiselect',
source: interests,
title: 'Interests',
placeholder: 'Select interests',
sourceSortFunction: sortAlphabetically,
filteringCaseSensitive: true,
},
]}
height="auto"
stretchH="last"
width="100%"
/>
);
};
export default ExampleComponent;
TypeScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const requiredItems: string[] = ['Passport', 'Tickets', 'Wallet', 'Phone', 'Keys'];
const optionalExtras: string[] = ['Snacks', 'Book', 'Camera', 'Umbrella', 'First aid kit'];
const interests: string[] = ['Art', 'History', 'Nature', 'Food', 'Shopping'];
const sortAlphabetically = (entries: (string | object)[]) =>
[...entries].sort((a, b) => String(a).localeCompare(String(b)));
const data: string[][][] = [
[['Passport', 'Phone'], ['Snacks', 'Book'], ['Nature']],
[['Tickets', 'Wallet'], ['Camera'], []],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
];
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
columns={[
{
type: 'multiselect',
source: requiredItems,
title: 'Required items',
allowEmpty: false,
},
{
type: 'multiselect',
source: optionalExtras,
title: 'Optional extras',
placeholder: 'Select up to 3',
maxSelections: 3,
visibleRows: 4,
searchInput: false,
},
{
type: 'multiselect',
source: interests,
title: 'Interests',
placeholder: 'Select interests',
sourceSortFunction: sortAlphabetically,
filteringCaseSensitive: true,
},
]}
height="auto"
stretchH="last"
width="100%"
/>
);
};
export default ExampleComponent;

API methods

When working with object-based MultiSelect data, you can use methods like getSourceData(), getSourceDataAtCell(), getSourceDataAtRow() etc., to get the data array in its original object format with both key and value properties. The getData() method will return only the value property’s value in the array.

Result

After configuring the multiselect cell type, cells display a dropdown that allows selecting multiple items. Each selected value appears as a removable chip inside the cell. The underlying data source stores the selections as an array (or as a comma-separated string when used with the Formulas plugin).

Related guides

Related blog articles

Configuration options

Core methods

Hooks

Skip to content

MultiSelect cell type

Collect user input with a list of multiple-selection choices, by using the MultiSelect cell type.

The multiselect cell type lets users pick multiple values from a dropdown list. Values are stored as a comma-separated string or array.

Overview

The MultiSelect cell type is designed for scenarios where you need to save and manage a list of values within a single cell. With this cell type, users can open a dropdown menu containing all available options and select any number of values, rather than being limited to just one.

Once selections are made, the values are stored in the table’s source data as an array associated with that particular cell. This approach provides both flexibility and clarity when working with datasets that require multiple values per field.

For a clear visual representation, the MultiSelect renderer displays each selected value as an individual, removable chip within the cell. This makes it easy for users to see exactly which values are selected at a glance and to remove any item with a single action if needed.

The list of selectable options (source property) can be provided in two formats:

  • An array of values
  • An array of objects with key and value properties

Integration with formulas

When you use the MultiSelect cell type together with the Formulas plugin, Handsontable keeps MultiSelect values in source data as arrays.

HyperFormula doesn’t accept arrays as direct cell values. Because of that, Handsontable converts MultiSelect arrays to comma-separated strings before passing values to HyperFormula. This behavior keeps the original array format in source data, and allows formula cells to reference MultiSelect values as text (for example, "Frontend, Backend").

The source option

The source option can be provided in two formats:

Array of values

You can provide the source option as an array of values that will be used as the MultiSelect options.

TypeScript
/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings, HotTableModule} from '@handsontable/angular-wrapper';
const shipmentCategories = [
'Electronics and Gadgets',
'Medical Supplies',
'Auto Parts',
'Fresh Produce',
'Textiles',
'Industrial Equipment',
'Pharmaceuticals',
'Consumer Goods',
'Machine Parts',
'Food Products',
];
const data = [
['Los Angeles International Airport', ['Electronics and Gadgets', 'Medical Supplies']],
['Chicago O\'Hare International Airport', ['Auto Parts', 'Fresh Produce']],
['Charles de Gaulle Airport', ['Textiles', 'Industrial Equipment']],
['Tokyo Haneda Airport', ['Pharmaceuticals', 'Consumer Goods']],
['Singapore Changi Airport', ['Machine Parts', 'Food Products']],
];
@Component({
selector: 'example1-multiselect-cell-type',
standalone: true,
imports: [HotTableModule],
template: ` <div>
<hot-table [data]="data" [settings]="gridSettings"></hot-table>
</div>`,
})
export class AppComponent {
readonly data = data;
readonly gridSettings: GridSettings = {
height: 200,
autoWrapRow: true,
autoWrapCol: true,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
preventOverflow: 'horizontal',
colWidths: 300,
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example1-multiselect-cell-type></example1-multiselect-cell-type>
</div>

Array of objects

You can provide the source option as an array of objects with key and value properties. The value property will be used as the MultiSelect’s option label, while the entire object will be used as the value saved to the cell’s source data.

TypeScript
/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings, HotTableModule} from '@handsontable/angular-wrapper';
const shipmentCategories = [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
];
const data = [
['Los Angeles International Airport', [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
]],
['Chicago O\'Hare International Airport', [
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
]],
['Charles de Gaulle Airport', [
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
]],
['Tokyo Haneda Airport', [
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
]],
['Singapore Changi Airport', [
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
]],
];
@Component({
selector: 'example2-multiselect-cell-type',
standalone: true,
imports: [HotTableModule],
template: ` <div>
<hot-table [data]="data" [settings]="gridSettings"></hot-table>
</div>`,
})
export class AppComponent {
readonly data = data;
readonly gridSettings: GridSettings = {
height: 200,
autoWrapRow: true,
autoWrapCol: true,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
preventOverflow: 'horizontal',
colWidths: 300,
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example2-multiselect-cell-type></example2-multiselect-cell-type>
</div>

Keyboard navigation

The MultiSelect editor is a dropdown with selectable items. You can select items by clicking them or by using the keyboard:

When the dropdown opens, the initial focus depends on the searchInput option: if filtering is enabled, the search input is focused by default; if filtering is disabled, the first item in the list is focused.

  • – Move the focus between items in the dropdown list. When the search input is visible, use to move focus from the search input into the list, and to move focus back into the search input.
  • Space or Enter – Toggle the selection of the focused item. The behavior depends on the enterCommits option:
    • When enterCommits is true (default): Enter closes the editor and commits the selection; Space toggles the focused item’s selection.
    • When enterCommits is false: Enter toggles the focused item’s selection; Space has no effect.

Each selection (or deselection) immediately updates the underlying cell data.

Other options

The MultiSelect cell type provides several configuration options to tailor its behavior:

  • allowEmpty – Allows empty cell value to pass validation. This is set to true by default.
  • placeholder – Sets placeholder text that’s rendered in the cell when the cell is empty.
  • visibleRows – Defines the maximum number of visible rows in the dropdown menu.
  • maxSelections – Determines the maximum number of items that can be selected.
  • sourceSortFunction – A custom sort function to order the dropdown entries.
  • enterCommits – Controls whether pressing the Enter key closes the editor and commits the selection.
  • searchInput – Toggles the visibility of the search input inside the dropdown.
  • filteringCaseSensitive – When set to true, the dropdown’s search filtering is case sensitive.

These options allow you to modify the MultiSelect cell type’s appearance, usability, and behavior to better fit your specific needs.

The demo below showcases some the options in an interactive example.

TypeScript
/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings, HotTableModule} from '@handsontable/angular-wrapper';
const requiredItems = ['Passport', 'Tickets', 'Wallet', 'Phone', 'Keys'];
const optionalExtras = ['Snacks', 'Book', 'Camera', 'Umbrella', 'First aid kit'];
const interests = ['Art', 'History', 'Nature', 'Food', 'Shopping'];
const sortAlphabetically = (entries: string[]) =>
[...entries].sort((a, b) => String(a).localeCompare(String(b)));
const data = [
[['Passport', 'Phone'], ['Snacks', 'Book'], ['Nature']],
[['Tickets', 'Wallet'], ['Camera'], []],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
];
@Component({
selector: 'example3-multiselect-cell-type',
standalone: true,
imports: [HotTableModule],
template: ` <div>
<hot-table [data]="data" [settings]="gridSettings"></hot-table>
</div>`,
})
export class AppComponent {
readonly data = data;
readonly gridSettings: GridSettings = {
height: 200,
autoWrapRow: true,
autoWrapCol: true,
columns: [
{
type: 'multiselect',
source: requiredItems,
title: 'Required items',
allowEmpty: false,
},
{
type: 'multiselect',
source: optionalExtras,
title: 'Optional extras',
placeholder: 'Select up to 3',
maxSelections: 3,
visibleRows: 4,
searchInput: false,
},
{
type: 'multiselect',
source: interests,
title: 'Interests',
placeholder: 'Select interests',
sourceSortFunction: sortAlphabetically,
filteringCaseSensitive: true,
},
],
preventOverflow: 'horizontal',
colWidths: 200,
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example3-multiselect-cell-type></example3-multiselect-cell-type>
</div>

API methods

When working with object-based MultiSelect data, you can use methods like getSourceData(), getSourceDataAtCell(), getSourceDataAtRow() etc., to get the data array in its original object format with both key and value properties. The getData() method will return only the value property’s value in the array.

Result

After configuring the multiselect cell type, cells display a dropdown that allows selecting multiple items. Each selected value appears as a removable chip inside the cell. The underlying data source stores the selections as an array (or as a comma-separated string when used with the Formulas plugin).

Related guides

Related blog articles

Configuration options

Core methods

Hooks

Skip to content

MultiSelect cell type

Collect user input with a list of multiple-selection choices, by using the MultiSelect cell type.

The multiselect cell type lets users pick multiple values from a dropdown list. Values are stored as a comma-separated string or array.

Overview

The MultiSelect cell type is designed for scenarios where you need to save and manage a list of values within a single cell. With this cell type, users can open a dropdown menu containing all available options and select any number of values, rather than being limited to just one.

Once selections are made, the values are stored in the table’s source data as an array associated with that particular cell. This approach provides both flexibility and clarity when working with datasets that require multiple values per field.

For a clear visual representation, the MultiSelect renderer displays each selected value as an individual, removable chip within the cell. This makes it easy for users to see exactly which values are selected at a glance and to remove any item with a single action if needed.

The list of selectable options (source property) can be provided in two formats:

  • An array of values
  • An array of objects with key and value properties

Integration with formulas

When you use the MultiSelect cell type together with the Formulas plugin, Handsontable keeps MultiSelect values in source data as arrays.

HyperFormula doesn’t accept arrays as direct cell values. Because of that, Handsontable converts MultiSelect arrays to comma-separated strings before passing values to HyperFormula. This behavior keeps the original array format in source data, and allows formula cells to reference MultiSelect values as text (for example, "Frontend, Backend").

The source option

The source option can be provided in two formats:

Array of values

You can provide the source option as an array of values that will be used as the MultiSelect options.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modules
registerAllModules();
const shipmentCategories: string[] = [
'Electronics and Gadgets',
'Medical Supplies',
'Auto Parts',
'Fresh Produce',
'Textiles',
'Industrial Equipment',
'Pharmaceuticals',
'Consumer Goods',
'Machine Parts',
'Food Products',
];
const data: (string | string[])[][] = [
['Los Angeles International Airport', ['Electronics and Gadgets', 'Medical Supplies']],
["Chicago O'Hare International Airport", ['Auto Parts', 'Fresh Produce']],
['Charles de Gaulle Airport', ['Textiles', 'Industrial Equipment']],
['Tokyo Haneda Airport', ['Pharmaceuticals', 'Consumer Goods']],
['Singapore Changi Airport', ['Machine Parts', 'Food Products']],
['Luton Airport', ['Electronics and Gadgets', 'Pharmaceuticals']],
['Frankfurt Airport', ['Industrial Equipment', 'Auto Parts', 'Consumer Goods']],
['Sydney Kingsford Smith Airport', ['Fresh Produce', 'Food Products']],
['Toronto Pearson International Airport', ['Medical Supplies', 'Textiles']],
['Hong Kong International Airport', ['Machine Parts', 'Electronics and Gadgets', 'Industrial Equipment']],
['Heathrow Airport', ['Textiles', 'Consumer Goods']],
];
const hotSettings = ref<GridSettings>({
data,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

Array of objects

You can provide the source option as an array of objects with key and value properties. The value property will be used as the MultiSelect’s option label, while the entire object will be used as the value saved to the cell’s source data.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modules
registerAllModules();
interface ShipmentCategory {
key: string;
value: string;
}
const shipmentCategories: ShipmentCategory[] = [
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
];
const data: (string | ShipmentCategory[])[][] = [
[
'Los Angeles International Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'medical', value: 'Medical Supplies' },
],
],
[
"Chicago O'Hare International Airport",
[
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'fresh-produce', value: 'Fresh Produce' },
],
],
[
'Charles de Gaulle Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Tokyo Haneda Airport',
[
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Singapore Changi Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Luton Airport',
[
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'pharmaceuticals', value: 'Pharmaceuticals' },
],
],
[
'Frankfurt Airport',
[
{ key: 'industrial', value: 'Industrial Equipment' },
{ key: 'auto-parts', value: 'Auto Parts' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
[
'Sydney Kingsford Smith Airport',
[
{ key: 'fresh-produce', value: 'Fresh Produce' },
{ key: 'food', value: 'Food Products' },
],
],
[
'Toronto Pearson International Airport',
[
{ key: 'medical', value: 'Medical Supplies' },
{ key: 'textiles', value: 'Textiles' },
],
],
[
'Hong Kong International Airport',
[
{ key: 'machine-parts', value: 'Machine Parts' },
{ key: 'electronics', value: 'Electronics and Gadgets' },
{ key: 'industrial', value: 'Industrial Equipment' },
],
],
[
'Heathrow Airport',
[
{ key: 'textiles', value: 'Textiles' },
{ key: 'consumer', value: 'Consumer Goods' },
],
],
];
const hotSettings = ref<GridSettings>({
data,
columns: [
{
title: 'Airport',
},
{
type: 'multiselect',
source: shipmentCategories,
title: 'Shipment',
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example2">
<HotTable :settings="hotSettings" />
</div>
</template>

Keyboard navigation

The MultiSelect editor is a dropdown with selectable items. You can select items by clicking them or by using the keyboard:

When the dropdown opens, the initial focus depends on the searchInput option: if filtering is enabled, the search input is focused by default; if filtering is disabled, the first item in the list is focused.

  • – Move the focus between items in the dropdown list. When the search input is visible, use to move focus from the search input into the list, and to move focus back into the search input.
  • Space or Enter – Toggle the selection of the focused item. The behavior depends on the enterCommits option:
    • When enterCommits is true (default): Enter closes the editor and commits the selection; Space toggles the focused item’s selection.
    • When enterCommits is false: Enter toggles the focused item’s selection; Space has no effect.

Each selection (or deselection) immediately updates the underlying cell data.

Other options

The MultiSelect cell type provides several configuration options to tailor its behavior:

  • allowEmpty – Allows empty cell value to pass validation. This is set to true by default.
  • placeholder – Sets placeholder text that’s rendered in the cell when the cell is empty.
  • visibleRows – Defines the maximum number of visible rows in the dropdown menu.
  • maxSelections – Determines the maximum number of items that can be selected.
  • sourceSortFunction – A custom sort function to order the dropdown entries.
  • enterCommits – Controls whether pressing the Enter key closes the editor and commits the selection.
  • searchInput – Toggles the visibility of the search input inside the dropdown.
  • filteringCaseSensitive – When set to true, the dropdown’s search filtering is case sensitive.

These options allow you to modify the MultiSelect cell type’s appearance, usability, and behavior to better fit your specific needs.

The demo below showcases some the options in an interactive example.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modules
registerAllModules();
const requiredItems: string[] = ['Passport', 'Tickets', 'Wallet', 'Phone', 'Keys'];
const optionalExtras: string[] = ['Snacks', 'Book', 'Camera', 'Umbrella', 'First aid kit'];
const interests: string[] = ['Art', 'History', 'Nature', 'Food', 'Shopping'];
const sortAlphabetically = (entries: (string | object)[]) =>
[...entries].sort((a, b) => String(a).localeCompare(String(b)));
const data: string[][][] = [
[['Passport', 'Phone'], ['Snacks', 'Book'], ['Nature']],
[['Tickets', 'Wallet'], ['Camera'], []],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
[['Phone', 'Keys'], ['First aid kit', 'Snacks', 'Umbrella'], ['Nature']],
[['Wallet', 'Phone'], [], ['Food', 'Shopping']],
[['Passport', 'Tickets'], ['Book'], ['Art', 'History']],
];
const hotSettings = ref<GridSettings>({
data,
columns: [
{
type: 'multiselect',
source: requiredItems,
title: 'Required items',
allowEmpty: false,
},
{
type: 'multiselect',
source: optionalExtras,
title: 'Optional extras',
placeholder: 'Select up to 3',
maxSelections: 3,
visibleRows: 4,
searchInput: false,
},
{
type: 'multiselect',
source: interests,
title: 'Interests',
placeholder: 'Select interests',
sourceSortFunction: sortAlphabetically,
filteringCaseSensitive: true,
},
],
autoWrapRow: true,
autoWrapCol: true,
height: 'auto',
stretchH: 'last',
width: '100%',
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example3">
<HotTable :settings="hotSettings" />
</div>
</template>

API methods

When working with object-based MultiSelect data, you can use methods like getSourceData(), getSourceDataAtCell(), getSourceDataAtRow() etc., to get the data array in its original object format with both key and value properties. The getData() method will return only the value property’s value in the array.

Result

After configuring the multiselect cell type, cells display a dropdown that allows selecting multiple items. Each selected value appears as a removable chip inside the cell. The underlying data source stores the selections as an array (or as a comma-separated string when used with the Formulas plugin).

Related guides

Related blog articles

Configuration options

Core methods

Hooks